View Issue Details

IDProjectCategoryView StatusLast Update
0006549Talerwallet (Android App)public2020-10-03 14:10
ReporterFlorian Dold Assigned Togrote  
PriorityhighSeverityminorReproducibilityhave not tried
Status resolvedResolutionfixed 
Target Version0.8Fixed in Version0.8 
Summary0006549: support the harmonized error detail format
DescriptionWe've now harmonized on the following error format across all components:

// (was TalerErrorDetails, but that's confusing)
export interface TalerErrorInfo {
  code: number;
  hint?: string;
  message?: string;
  details?: unknown;
}

The wallet-core uses this format in v0.7.1-dev.23

What needs to be updated is:
* wallet-core documentation
* Android implementation
TagsNo tags attached.

Activities

grote

2020-09-01 15:46

developer   ~0016802

Is this replacing WalletErrorInfo https://docs.taler.net/taler-wallet.html#tsref-type-WalletErrorInfo or is this the 'details' of WalletErrorInfo?

Btw. the datails of TalerErrorDetails still have an unknown type.

Florian Dold

2020-09-01 15:55

manager   ~0016804

Ah, maybe it's not a good idea to call it TalerErrorDetails then, that's confusing. How about TalerErrorInfo? The TalerErrorInfo contains the details.

(That's just for the documentation though, this name will never appear in the actual messages.)

This affects both the WalletErrorInfo and the TransactionError. They're both TalerErrorInfo now. Other Taler services (exchange, merchant, bank) return / should return TalerErrorInfo (right now, some of them do not include the "details" object yet, but instead pull various details to the top-level).

The details field will in general be of type "unknown", but we will narrow down the type for certain error codes. I.e. there will be definitions like

interface FooErrorInfo extends TalerErrorInfo {
  code: 424242,
  details: FooErrorDetails;
}

interface FooErrorDetails {
  spam: number;
  eggs: string[];
}

grote

2020-09-01 16:01

developer   ~0016805

Just to be sure I understand what is going on. The former WalletErrorInfo has changed and is replaced by the new TalerErrorDetails (or now TalerErrorInfo)? Right?

Florian Dold

2020-09-01 16:03

manager   ~0016806

Yes. The same goes for the TransactionError: It has been replaced by TalerErrorInfo.

(The motivation for this is that we should have only one "error info format" across the whole Taler project.)

grote

2020-09-01 16:34

developer   ~0016808

ok, implemented in the android app in c928b458

Issue History

Date Modified Username Field Change
2020-09-01 15:05 Florian Dold New Issue
2020-09-01 15:05 Florian Dold Status new => assigned
2020-09-01 15:05 Florian Dold Assigned To => grote
2020-09-01 15:46 grote Note Added: 0016802
2020-09-01 15:55 Florian Dold Note Added: 0016804
2020-09-01 15:56 Florian Dold Description Updated View Revisions
2020-09-01 16:01 grote Note Added: 0016805
2020-09-01 16:03 Florian Dold Note Added: 0016806
2020-09-01 16:34 grote Note Added: 0016808
2020-09-28 19:46 grote Status assigned => resolved
2020-09-28 19:46 grote Resolution open => fixed
2020-10-03 14:08 Christian Grothoff Fixed in Version => 0.8
2020-10-03 14:10 Christian Grothoff Target Version => 0.8